## flexml 1-5

=== Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.24 1999/12/09 16:48:35 krisrose Exp krisrose $

# FILES.

STUFF =	GPL Makefile flexml.pl FleXML.html
BINS =	flexml
LIBS =	flexml-act
DATA =	skel
MANS =	flexml.1
DOCS =	README flexml-act.dtd EnlargeFlex.patch
HTMLS =	index.html flexml.html paper.html
SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
	tricky.dtd tricky.act tricky.xml \
	test.html

SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS) $(SAMPS)
ALL =	$(PROGS) $(LIBS) $(DATA) $(MANS) $(DOCS) $(HTMLS) $(SAMPS)

# SETUP.

# Installation paths
USR = /usr
BINDIR = $(USR)/bin
LIBDIR = $(USR)/lib
SHARE = /usr/share
MAN1DIR = $(SHARE)/man/man1
DOCDIR = $(SHARE)/doc
DATADIR = $(SHARE)/flexml
TMPDIR = /var/tmp

# Permanent program locations
PERL = /usr/bin/perl
FLEX = /usr/bin/flex
FLEXML = $(BINDIR)/flexml
ACT = $(LIBDIR)/flexml-act
SKEL = $(DATADIR)/skel

# Build compilation setup.
CC = gcc -Wall -ansi -pedantic
CFLAGS = -O2 -g
#FLEXDEBUG = -d

# Web location.

WEBHOME = info:public_html
FTPHOME = info:public_html/ftp/FleXML

# PRIMARY TARGETS.

.PHONY:		all install dist test clean

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(BINDIR) $(DESTDIR)$(LIBDIR) \
		$(DESTDIR)$(MAN1DIR) $(DESTDIR)$(DOCDIR) \
		$(DESTDIR)$(DATADIR) \
		$(DESTDIR)$(DOCDIR)/flexml/html \
		$(DESTDIR)$(DOCDIR)/flexml/examples
	install -m555 $(BINS) $(DESTDIR)$(BINDIR)/
	install -m555 $(LIBS) $(DESTDIR)$(LIBDIR)/
	install -m444 $(DATA) $(DESTDIR)$(DATADIR)/
	install -m444 $(MANS) $(DESTDIR)$(MAN1DIR)/
	install -m444 $(DOCS) $(DESTDIR)$(DOCDIR)/flexml/
	install -m444 $(HTMLS) $(DESTDIR)$(DOCDIR)/flexml/html/
	install -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/

dist:		clean
	rsync -v FleXML.html $(WEBHOME)/FleXML.html
	rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning..."
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*
test::		all
	@echo "Testing..."

# DEFAULT RULES.

# Generate C source from flex scanner.
%.c: 		%.l
	$(FLEX) -Bsv $(FLEXDEBUG) -o$@ $<

# Direct generation of stand-alone XML processor+application.
# Note: The dependency must be of the form "appl.l: appl.act proc.dtd".
%.l:		%.act
	./flexml.pl $(FLEXDEBUG) -vA -a $^

# Generate XML processor to link with application.
%.l %.h:	%.dtd
	./flexml.pl $(FLEXDEBUG) -v -s skel $<

# Generate XML application C source to compile and link with processor.
# Note: The dependency must be of the form "appl.c: appl.act proc.dtd".
%.c:		%.act
	./flexml.pl $(FLEXDEBUG) -vD -a $^


# MAIN PROGRAM.

clean::; $(RM) flexml flexml-act flexml-act.c

flexml:		flexml.pl
	sed -e "s;^[#][!].*perl;#!$(PERL);" \
	    -e "s;[.][/]flexml-act;$(ACT);g" \
	    -e "s;[.][/]skel;$(SKEL);g" \
	    -e "s;/var/tmp;$(TMPDIR);g" \
	    -e "s;/usr/share/doc/;$(DOCDIR)/;g" flexml.pl >flexml
	chmod +x flexml

# Action language...
flexml-act.l:		flexml-act.dtd
	./flexml.pl $(FLEXDEBUG) -Lv -ractions -s skel $<

flexml-act.c:		flexml-act.l
	$(FLEX) -Bsv -oflexml-act.c flexml-act.l

flexml-act.o:		flexml-act.c flexml-act.h
flexml-act-bootstrap.o:	flexml-act-bootstrap.c flexml-act.h
flexml-act:		flexml-act.o flexml-act-bootstrap.o

clean::; $(RM) TAGS
TAGS: 	$(SRC);	etags $(SRC)
ci:	$(SRC);	ci -u $(SRC)

# DOCUMENTS.

clean::; $(RM) flexml.html index.html pod2html-*

flexml.1:	flexml
	pod2man flexml >flexml.1

flexml.html:	flexml
	pod2html <flexml >flexml.html

index.html:	FleXML.html
	sed 's.ftp/FleXML/..g' FleXML.html >index.html

# TESTS.

# Example: LINK processor with application:

my.l my.h:	my.dtd
my.c:		my.l
my.o:		my.c my.h

my-show.c:	my-show.act my.dtd
my-show.o:	my-show.c my.h
my-show:	my-show.o my.o

test::		my-show
	./my-show <my-joke.xml && echo OK
	./my-show <my-joke2.xml && echo OK
	./my-show <my-joke3.xml || echo OK

clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c

# Example: COMPILE processor into application

tricky.l:	tricky.act tricky.dtd
tricky.c:	tricky.l
tricky.o:	tricky.c
tricky:		tricky.o

test::		tricky
	./tricky <tricky.xml

clean::; $(RM) tricky.[lco] tricky

# Complex example: application to print XHTML <a href=...> values.
# XHTML is big, so...we must use a patched flex (included in Debian).


xhtml1-transitional.dtd:
	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'

xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
	./flexml.pl $(FLEXDEBUG) -sskel -rhtml \
		-p "-//W3C//DTD XHTML 1.0 Transitional//EN" \
		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
		xhtml1-transitional.dtd

xhtml1-transitional.c:	xhtml1-transitional.l
	$(FLEX) -Bsv -Ca -oxhtml1-transitional.c xhtml1-transitional.l

xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h

xhtml-href.c:	xhtml-href.act xhtml1-transitional.dtd
xhtml-href.o:	xhtml-href.c xhtml1-transitional.h
xhtml-href:	xhtml-href.o xhtml1-transitional.o

test::		xhtml-href
	./xhtml-href <test.html
	./xhtml-href <FleXML.html

clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href

# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."

=== debian/changelog ===
flexml (1-5) unstable; urgency=low

  * doc-base fixed (and bogus menu removed).
  * HTML documentation cleaned up.

 -- Kristoffer H. Rose <krisrose@debian.org>  Mon, 13 Dec 1999 17:00:32 +0100

flexml (1-4) unstable; urgency=low

  * Oops: install in skel, not skel/skel [sic].

 -- Kristoffer H. Rose <krisrose@debian.org>  Thu,  9 Dec 1999 17:45:23 +0100

flexml (1-3) unstable; urgency=low

  * Added perl -w option and eliminated all encountered warnings.
  * Use LWP to DTDs and external entities specified by URI.

 -- Kristoffer Rose <krisrose@debian.org>  Thu,  9 Dec 1999 04:37:26 +0100

flexml (1-2) unstable; urgency=low

  * Fixed version oops.
  * DTD parser and state transition tables cleaned up somewhat.
  * Can now correctly generate the `xhtml-href' application.

 -- Kristoffer H. Rose <krisrose@debian.org>  Mon,  6 Dec 1999 22:06:43 +0100

flexml (1-1) unstable; urgency=low

  * Manual page and program fully in sync.
  * Introductory document added.
  * Application-generation tested some.
  * flexml.skel renamed to skel [sic].
  * Several printf formats fixed.
  * Optimizations to avoid scanner backup on valid documents.
  * Further development...

 -- Kristoffer H. Rose <krisrose@debian.org>  Thu, 25 Nov 1999 19:38:29 +0100

flexml (1-0) unstable; urgency=low

  * Initial Release.

 -- Kristoffer H. Rose <krisrose@debian.org>  Tue, 23 Nov 1999 11:41:52 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address: "krisrose@debian.org"
End:

=== debian/control ===
Source: flexml
Section: devel
Priority: optional
Maintainer: Kristoffer H. Rose <krisrose@debian.org>
Standards-Version: 3.0.1

Package: flexml
Architecture: any
Depends: ${shlibs:Depends}, perl5, libwww-perl
Recommends: flex
Description: Generate fast validating XML processors and applications.
 FleXML makes it easy to generate very fast validating XML processors
 as flex(1) source.
 .
 By design it can only handle documents using an external DTD.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=1

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	-$(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) install DESTDIR=`pwd`/debian/tmp
	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installmanpages
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## flexml 1-6.1

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.24 1999/12/09 16:48:35 krisrose Exp krisrose $
+# $Id: Makefile,v 1.26 2001/08/31 03:51:23 shack Exp $
 
 # FILES.
 
@@ -29,9 +29,10 @@
 MANS =	flexml.1
 DOCS =	README flexml-act.dtd EnlargeFlex.patch
 HTMLS =	index.html flexml.html paper.html
-SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
-	tricky.dtd tricky.act tricky.xml \
-	test.html
+SAMPS =	
+#SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
+#	tricky.dtd tricky.act tricky.xml \
+#	test.html
 
 SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS) $(SAMPS)
 ALL =	$(PROGS) $(LIBS) $(DATA) $(MANS) $(DOCS) $(HTMLS) $(SAMPS)
@@ -83,11 +84,11 @@
 	install -m444 $(MANS) $(DESTDIR)$(MAN1DIR)/
 	install -m444 $(DOCS) $(DESTDIR)$(DOCDIR)/flexml/
 	install -m444 $(HTMLS) $(DESTDIR)$(DOCDIR)/flexml/html/
-	install -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/
+	make -C examples install
 
 dist:		clean
-	rsync -v FleXML.html $(WEBHOME)/FleXML.html
-	rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/
+	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
+	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/
 
 clean::; @echo "Cleaning..."
 	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*
@@ -157,62 +158,8 @@
 
 # TESTS.
 
-# Example: LINK processor with application:
-
-my.l my.h:	my.dtd
-my.c:		my.l
-my.o:		my.c my.h
-
-my-show.c:	my-show.act my.dtd
-my-show.o:	my-show.c my.h
-my-show:	my-show.o my.o
-
-test::		my-show
-	./my-show <my-joke.xml && echo OK
-	./my-show <my-joke2.xml && echo OK
-	./my-show <my-joke3.xml || echo OK
-
-clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c
-
-# Example: COMPILE processor into application
-
-tricky.l:	tricky.act tricky.dtd
-tricky.c:	tricky.l
-tricky.o:	tricky.c
-tricky:		tricky.o
-
-test::		tricky
-	./tricky <tricky.xml
-
-clean::; $(RM) tricky.[lco] tricky
-
-# Complex example: application to print XHTML <a href=...> values.
-# XHTML is big, so...we must use a patched flex (included in Debian).
-
-
-xhtml1-transitional.dtd:
-	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'
-
-xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
-	./flexml.pl $(FLEXDEBUG) -sskel -rhtml \
-		-p "-//W3C//DTD XHTML 1.0 Transitional//EN" \
-		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
-		xhtml1-transitional.dtd
-
-xhtml1-transitional.c:	xhtml1-transitional.l
-	$(FLEX) -Bsv -Ca -oxhtml1-transitional.c xhtml1-transitional.l
-
-xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h
-
-xhtml-href.c:	xhtml-href.act xhtml1-transitional.dtd
-xhtml-href.o:	xhtml-href.c xhtml1-transitional.h
-xhtml-href:	xhtml-href.o xhtml1-transitional.o
-
-test::		xhtml-href
-	./xhtml-href <test.html
-	./xhtml-href <FleXML.html
-
-clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href
+clean::; make -C examples $@
+test::; make -C examples $@
 
 # END.

=== examples/Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.1 2001/08/31 03:51:23 shack Exp $

# FILES.

SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
	tricky.dtd tricky.act tricky.xml \
	test.html

SRC =	$(SAMPS)
ALL =	$(SAMPS)

# SETUP.

# Installation paths
USR = /usr
BINDIR = $(USR)/bin
LIBDIR = $(USR)/lib
SHARE = /usr/share
MAN1DIR = $(SHARE)/man/man1
DOCDIR = $(SHARE)/doc
DATADIR = $(SHARE)/flexml
TMPDIR = /var/tmp

# Permanent program locations
PERL = /usr/bin/perl
FLEX = /usr/bin/flex
FLEXML = $(BINDIR)/flexml
ACT = $(LIBDIR)/flexml-act
SKEL = $(DATADIR)/skel

# Build compilation setup.
CC = gcc -Wall -ansi -pedantic
CFLAGS = -O2 -g
#FLEXDEBUG = -d

# PRIMARY TARGETS.

.PHONY:		all install dist test clean

start: test

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(DOCDIR)/flexml/examples
	install -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/

dist:		clean
	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning examples..."
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*

test::		all
	@echo "Testing..."

# DEFAULT RULES.

# Generate C source from flex scanner.
%.c: 		%.l
	$(FLEX) -Bsv $(FLEXDEBUG) -o$@ $<

# Direct generation of stand-alone XML processor+application.
# Note: The dependency must be of the form "appl.l: appl.act proc.dtd".
%.l:		%.act
	../flexml.pl $(FLEXDEBUG) -vA -a $^

# Generate XML processor to link with application.
%.l %.h:	%.dtd ../skel
	../flexml.pl $(FLEXDEBUG) -v -s ../skel $<

# Generate XML application C source to compile and link with processor.
# Note: The dependency must be of the form "appl.c: appl.act proc.dtd".
%.c:		%.act
	../flexml.pl $(FLEXDEBUG) -vD -a $^


# MAIN PROGRAM.

clean::; $(RM) flexml flexml-act flexml-act.c

flexml:		flexml.pl
	sed -e "s;^[#][!].*perl;#!$(PERL);" \
	    -e "s;[.][/]flexml-act;$(ACT);g" \
	    -e "s;[.][/]skel;$(SKEL);g" \
	    -e "s;/var/tmp;$(TMPDIR);g" \
	    -e "s;/usr/share/doc/;$(DOCDIR)/;g" flexml.pl >flexml
	chmod +x flexml

# Action language...
flexml-act.l:		flexml-act.dtd ../skel
	../flexml.pl $(FLEXDEBUG) -Lv -ractions -s ../skel $<

flexml-act.c:		flexml-act.l
	$(FLEX) -Bsv -oflexml-act.c flexml-act.l

flexml-act.o:		flexml-act.c flexml-act.h
flexml-act-bootstrap.o:	flexml-act-bootstrap.c flexml-act.h
flexml-act:		flexml-act.o flexml-act-bootstrap.o

# DOCUMENTS.

# TESTS.

# Example: LINK processor with application:

my.l my.h:	my.dtd
my.c:		my.l
my.o:		my.c my.h

my-show.c:	my-show.act my.dtd
my-show.o:	my-show.c my.h
my-show:	my-show.o my.o

test::		my-show
	./my-show <my-joke.xml && echo OK
	./my-show <my-joke2.xml && echo OK
	./my-show <my-joke3.xml || echo OK

clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c

# Example: COMPILE processor into application

tricky.l:	tricky.act tricky.dtd
tricky.c:	tricky.l
tricky.o:	tricky.c
tricky:		tricky.o

test::		tricky
	./tricky <tricky.xml

clean::; $(RM) tricky.[lco] tricky

# Complex example: application to print XHTML <a href=...> values.
# XHTML is big, so...we must use a patched flex (included in Debian).


xhtml1-transitional.dtd:
	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'

xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd ../skel
	./flexml.pl $(FLEXDEBUG) -s../skel -rhtml \
		-p "-//W3C//DTD XHTML 1.0 Transitional//EN" \
		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
		xhtml1-transitional.dtd

xhtml1-transitional.c:	xhtml1-transitional.l
	$(FLEX) -Bsv -Ca -oxhtml1-transitional.c xhtml1-transitional.l

xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h

xhtml-href.c:	xhtml-href.act xhtml1-transitional.dtd
xhtml-href.o:	xhtml-href.c xhtml1-transitional.h
xhtml-href:	xhtml-href.o xhtml1-transitional.o

test::		xhtml-href
	./xhtml-href <test.html
	./xhtml-href <FleXML.html

clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href

# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."

=== debian/changelog ===
flexml (1-6.1) unstable; urgency=low

  * Non-maintainer upload
  * Change the build-dep to flex-old 

 -- Pierre Machard <pmachard@debian.org>  Wed, 25 Jun 2003 10:25:24 +0200

flexml (1-6) unstable; urgency=low

  * Debian package synchronized with flexml.sourceforge.net.
  * Source dependencies added [thanks to ].

 -- Kristoffer Rose <krisrose@debian.org>  Tue, 11 Feb 2003 14:11:19 -0500

=== debian/control ===
Source: flexml
Section: devel
Priority: optional
Maintainer: Kristoffer H. Rose <krisrose@debian.org>
Build-Depends: libwww-perl, debhelper (>>4.0.0) , flex-old, liburi-perl, libdate-calc-perl
Standards-Version: 3.5.10

Package: flexml
Architecture: any
Depends: ${shlibs:Depends}, libwww-perl, liburi-perl, libdate-calc-perl
Recommends: flex
Description: Generate fast validating XML processors and applications
 FleXML makes it easy to generate very fast validating XML processors
 as flex(1) source.
 .
 By design it can only handle documents using an external DTD.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,6 @@
 	dh_testroot
 	rm -f build-stamp
 	-$(MAKE) clean
-
 	dh_clean
 
 install: build
@@ -48,7 +47,7 @@
 	dh_compress
 	dh_fixperms
 	dh_installdeb
-	dh_perl
+	dh_perl ./debian/tmp/usr/bin
 	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums

## flexml 1.3

=== Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.37 2005/04/06 10:25:52 mquinson Exp $

# SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
# resource files. To get rid of it (and do a non-versioned install,
# for example), do:
#   make whatever SUFF=

# FILES.

include Makefile.defs

STUFF =	GPL Makefile Makefile.defs flexml.pl FleXML.html
BINS  =	$(FLEXML)
LIBS  =	$(FLEXML_ACT)
DATA  =	skel
MANS  =	flexml.1
DOCS  =	README NOTES TODO flexml-act.dtd EnlargeFlex.patch
HTMLS =	FleXML.html paper.html

SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS)
ALL =	$(PROGS) $(LIBS) $(DATA) $(MANS) $(DOCS) $(HTMLS)

.PHONY:		all install dist test clean

# PRIMARY TARGETS.

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(BINDIR) $(DESTDIR)$(LIBDIR) \
		$(DESTDIR)$(MAN1DIR) $(DESTDIR)$(DOCDIR) \
		$(DESTDIR)$(DATADIR) \
		$(DESTDIR)$(DOCDIR)/html \
		$(DESTDIR)$(DOCDIR)/examples
	install -m555 $(BINS) $(DESTDIR)$(BINDIR)/
	install -m555 $(LIBS) $(DESTDIR)$(LIBDIR)/
	install -m444 $(DATA) $(DESTDIR)$(DATADIR)/
	install -m444 $(MANS) $(DESTDIR)$(MAN1DIR)/
	install -m444 $(DOCS) $(DESTDIR)$(DOCDIR)/
	install -m444 $(HTMLS) $(DESTDIR)$(DOCDIR)/html/
	if test "x$(SUFF)" != "x" ; then \
	  rm -f $(DESTDIR)$(BINDIR)/flexml; \
	  ln -s $(DESTDIR)$(BINDIR)/$(FLEXML) $(DESTDIR)$(BINDIR)/flexml;\
	fi
	make -C examples install

# This should probably be something different
FLEXML_DIR = $(FLEXML)

dist:		clean
	@echo "Building distribution..."
	mkdir $(FLEXML_DIR)
	cp $(STUFF) $(DATA) $(DOCS) $(HTMLS) flexml-act-bootstrap.c \
		$(FLEXML_DIR)
	cp -r examples $(FLEXML_DIR)
	find $(FLEXML_DIR) -name CVS | xargs rm -rf
	find $(FLEXML_DIR) -name .cvsignore | xargs rm -rf
	tar cvfz $(FLEXML_DIR).tar.gz $(FLEXML_DIR)
	rm -rf $(FLEXML_DIR)

	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning..."
	$(RM) -rf $(FLEXML_DIR).tar.gz $(FLEXML_DIR)
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*
	find -name '*~' | xargs $(RM)
test::		all
	@echo "Testing..."

clean::; $(RM) $(FLEXML) $(FLEXML_ACT) flexml-act flexml-act.c

$(FLEXML):		flexml.pl
	sed \
	    -e "s;[.][/]flexml-act;$(ACT);g" \
	    -e "s;[.][/]skel;$(SKEL);g" \
	    -e "s;/var/tmp;$(TMPDIR);g" \
	    -e "s;/usr/share/doc/;$(DOCDIR)/;g" flexml.pl > $@
	chmod +x $@

ifneq ($(SUFF),)
$(FLEXML_ACT): flexml-act
	cp flexml-act $@
endif

# Action language...
flexml-act.l:		flexml-act.dtd skel
	$(PERL) ./flexml.pl $(FLEXDEBUG) -Lv -ractions -s skel $<

flexml-act.c:		flexml-act.l
	$(FLEX) -B -s -v -oflexml-act.c flexml-act.l

flexml-act.o:		flexml-act.c flexml-act.h
flexml-act-bootstrap.o:	flexml-act-bootstrap.c flexml-act.h
flexml-act:		flexml-act.o flexml-act-bootstrap.o

clean::; $(RM) TAGS
TAGS: 	$(SRC);	etags $(SRC)
ci:	$(SRC);	ci -u $(SRC)

# DOCUMENTS.

clean::; $(RM) flexml.html index.html pod2html-*

flexml.1:	$(FLEXML)
	$(POD2MAN) $(FLEXML) > $@

flexml.html:	$(FLEXML)
	$(POD2HTML) < $(FLEXML) > $@

index.html:	FleXML.html
	sed 's.ftp/FleXML/..g' FleXML.html > $@

# TESTS.

clean::; make -C examples $@
test::; make -C examples $@

# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."

=== examples/Makefile ===
# Make(1) rules for FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This file is part of the FleXML XML processor generator system.
# Copyright  1999 Kristoffer Rose.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 02111-1307 USA.

# $Id: Makefile,v 1.4 2005/03/18 22:10:52 wdowling Exp $

# FILES.

include ../Makefile.defs

SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
	tricky.dtd tricky.act tricky.xml \
	test.html

SRC =	$(SAMPS)
ALL =	$(SAMPS)

.PHONY:		all install dist test clean

# PRIMARY TARGETS.

start: test

all:		$(ALL)

install:	$(ALL)
	mkdir -p $(DESTDIR)$(DOCDIR)/flexml/examples
	install -m444 $(SAMPS) $(DESTDIR)$(DOCDIR)/flexml/examples/

dist:		clean
	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

clean::; @echo "Cleaning examples..."
	$(RM) *.[olh1] *-dummy.? lex.* *~ ./#*

test::		all
	@echo "Testing..."


# DEFAULT RULES.
FLEXML_PROG = ../$(FLEXML)

# Generate C source from flex scanner.
%.c: 		%.l
	$(FLEX) -B -s -v $(FLEXDEBUG) -o$@ $<

# Direct generation of stand-alone XML processor+application.
# Note: The dependency must be of the form "appl.l: appl.act proc.dtd".
%.l:		%.act
	$(FLEXML_PROG) $(FLEXDEBUG) -vA -a $^

# Generate XML processor to link with application.
%.l %.h:	%.dtd
	$(FLEXML_PROG) $(FLEXDEBUG) -v $<

# Generate XML application C source to compile and link with processor.
# Note: The dependency must be of the form "appl.c: appl.act proc.dtd".
%.c:		%.act
	$(FLEXML_PROG) $(FLEXDEBUG) -vD -a $^


clean::; $(RM) flexml-act flexml-act.c

# Example: LINK processor with application:

my.l my.h:	my.dtd
my.c:		my.l
my.o:		my.c my.h

my-show.c:	my-show.act my.dtd
my-show.o:	my-show.c my.h
my-show:	my-show.o my.o

test::		my-show
	./my-show <my-joke.xml && echo OK
	./my-show <my-joke2.xml && echo OK
	./my-show <my-joke3.xml || echo OK

clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c

# Example: COMPILE processor into application

tricky.l:	tricky.act tricky.dtd
tricky.c:	tricky.l
tricky.o:	tricky.c
tricky:		tricky.o

test::		tricky
	./tricky <tricky.xml

clean::; $(RM) tricky.[lco] tricky

# Complex example: application to print XHTML <a href=...> values.

xhtml1-transitional.dtd:
	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'

xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
	../$(FLEXML) $(FLEXDEBUG) -rhtml \
		-p "-//IETF//DTD XHTML 1.0 Transitional//EN" \
		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
		xhtml1-transitional.dtd

xhtml1-transitional.c:	xhtml1-transitional.l
	$(FLEX) -B -s -v -Ca -oxhtml1-transitional.c xhtml1-transitional.l

xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h

xhtml-href.c:	xhtml-href.act xhtml1-transitional.dtd
xhtml-href.o:	xhtml-href.c xhtml1-transitional.h
xhtml-href:	xhtml-href.o xhtml1-transitional.o

test::		xhtml-href FleXML.xml
	./xhtml-href <test.html
	./xhtml-href < FleXML.xml

clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href

# END.

clean::; @echo "Done cleaning."
test::;	@echo "Done testing."

.PHONEY : echov

# on command line say 'make v=foo echov' to see the value
# of the variable foo
echov:
	@echo "$(subst ",\",$($(v)))";          #"# for emacs

## flexml 1.4.1

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.37 2005/04/06 10:25:52 mquinson Exp $
+# $Id: Makefile,v 1.39 2006/03/21 13:16:08 mquinson Exp $
 
 # SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
 # resource files. To get rid of it (and do a non-versioned install,
@@ -64,19 +64,17 @@
 	fi
 	make -C examples install
 
-# This should probably be something different
-FLEXML_DIR = $(FLEXML)
-
+FLEXML_DISTDIR = $(FLEXML)-$(VER)
 dist:		clean
 	@echo "Building distribution..."
-	mkdir $(FLEXML_DIR)
+	mkdir $(FLEXML_DISTDIR)
 	cp $(STUFF) $(DATA) $(DOCS) $(HTMLS) flexml-act-bootstrap.c \
-		$(FLEXML_DIR)
-	cp -r examples $(FLEXML_DIR)
-	find $(FLEXML_DIR) -name CVS | xargs rm -rf
-	find $(FLEXML_DIR) -name .cvsignore | xargs rm -rf
-	tar cvfz $(FLEXML_DIR).tar.gz $(FLEXML_DIR)
-	rm -rf $(FLEXML_DIR)
+		$(FLEXML_DISTDIR)
+	cp -r examples $(FLEXML_DISTDIR)
+	find $(FLEXML_DISTDIR) -name CVS | xargs rm -rf
+	find $(FLEXML_DISTDIR) -name .cvsignore | xargs rm -rf
+	tar cvfz $(FLEXML_DISTDIR).tar.gz $(FLEXML_DISTDIR)
+	rm -rf $(FLEXML_DISTDIR)
 
 	#rsync -v FleXML.html $(WEBHOME)/FleXML.html
 	#rsync -va --cvs-exclude --delete-excluded ./ $(FTPHOME)/

=== examples/Makefile ===
--- 
+++ 
@@ -18,11 +18,15 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.4 2005/03/18 22:10:52 wdowling Exp $
+# $Id: Makefile,v 1.5 2006/03/21 13:11:27 mquinson Exp $
 
 # FILES.
 
 include ../Makefile.defs
+
+# Test the version in this dir, not the installed one
+SKEL=../skel
+ACT=../flexml-act
 
 SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
 	tricky.dtd tricky.act tricky.xml \
@@ -55,7 +59,7 @@
 
 
 # DEFAULT RULES.
-FLEXML_PROG = ../$(FLEXML)
+FLEXML_PROG = ../$(FLEXML) -s$(SKEL) -T$(ACT)
 
 # Generate C source from flex scanner.
 %.c: 		%.l
@@ -89,9 +93,10 @@
 my-show:	my-show.o my.o
 
 test::		my-show
-	./my-show <my-joke.xml && echo OK
-	./my-show <my-joke2.xml && echo OK
-	./my-show <my-joke3.xml || echo OK
+	@echo "XXXXX Test: LINK processor with application"
+	if ./my-show <my-joke.xml  ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
+	if ./my-show <my-joke2.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
+	if ./my-show <my-joke3.xml ; then echo "TEST FAILED"; else echo "TEST PASSED"; fi
 
 clean::; $(RM) my.c my-show my-show.c my-dummy my-dummy.c
 
@@ -103,7 +108,8 @@
 tricky:		tricky.o
 
 test::		tricky
-	./tricky <tricky.xml
+	@echo "XXXXX Test: COMPILE processor with application"
+	if ./tricky <tricky.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
 
 clean::; $(RM) tricky.[lco] tricky
 
@@ -113,7 +119,7 @@
 	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'
 
 xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
-	../$(FLEXML) $(FLEXDEBUG) -rhtml \
+	$(FLEXML_PROG) -rhtml \
 		-p "-//IETF//DTD XHTML 1.0 Transitional//EN" \
 		-u "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" \
 		xhtml1-transitional.dtd
@@ -128,8 +134,9 @@
 xhtml-href:	xhtml-href.o xhtml1-transitional.o
 
 test::		xhtml-href FleXML.xml
-	./xhtml-href <test.html
-	./xhtml-href < FleXML.xml
+	@echo "XXXXX Test: application to print XHTML <a href=...> values"
+	if ./xhtml-href <test.html   ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
+	if ./xhtml-href < FleXML.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
 
 clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href
 
@@ -137,6 +144,7 @@
 
 clean::; @echo "Done cleaning."
 test::;	@echo "Done testing."
+test:: clean
 
 .PHONEY : echov

## flexml 1.7

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # Make(1) rules for FleXML XML processor generator system.
-# Copyright  1999 Kristoffer Rose.  All rights reserved.
+# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
 #
 # This file is part of the FleXML XML processor generator system.
-# Copyright  1999 Kristoffer Rose.  All rights reserved.
+# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.39 2006/03/21 13:16:08 mquinson Exp $
+# $Id: Makefile,v 1.42 2006/08/23 16:23:59 mquinson Exp $
 
 # SUFF (defined in Makefile.defs) is the versioning suffix added to binaries and
 # resource files. To get rid of it (and do a non-versioned install,
@@ -34,7 +34,7 @@
 LIBS  =	$(FLEXML_ACT)
 DATA  =	skel
 MANS  =	flexml.1
-DOCS  =	README NOTES TODO flexml-act.dtd EnlargeFlex.patch
+DOCS  =	README NOTES TODO flexml-act.dtd
 HTMLS =	FleXML.html paper.html
 
 SRC =	$(STUFF) $(DATA) $(DOCS) $(HTMLS)
@@ -70,7 +70,7 @@
 	mkdir $(FLEXML_DISTDIR)
 	cp $(STUFF) $(DATA) $(DOCS) $(HTMLS) flexml-act-bootstrap.c \
 		$(FLEXML_DISTDIR)
-	cp -r examples $(FLEXML_DISTDIR)
+	cp -r examples testbed $(FLEXML_DISTDIR)
 	find $(FLEXML_DISTDIR) -name CVS | xargs rm -rf
 	find $(FLEXML_DISTDIR) -name .cvsignore | xargs rm -rf
 	tar cvfz $(FLEXML_DISTDIR).tar.gz $(FLEXML_DISTDIR)
@@ -131,8 +131,8 @@
 
 # TESTS.
 
-clean::; make -C examples $@
-test::; make -C examples $@
+clean::; make -C examples $@; make -C testbed $@
+test::;  make -C examples $@; make -C testbed $@
 
 # END.

=== examples/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # Make(1) rules for FleXML XML processor generator system.
-# Copyright  1999 Kristoffer Rose.  All rights reserved.
+# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
 #
 # This file is part of the FleXML XML processor generator system.
-# Copyright  1999 Kristoffer Rose.  All rights reserved.
+# Copyright (c) 1999 Kristoffer Rose.  All rights reserved.
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the Free
@@ -18,7 +18,7 @@
 # with this program; if not, write to the Free Software Foundation, Inc., 59
 # Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 
-# $Id: Makefile,v 1.5 2006/03/21 13:11:27 mquinson Exp $
+# $Id: Makefile,v 1.8 2006/08/28 20:50:38 wdowling Exp $
 
 # FILES.
 
@@ -30,7 +30,7 @@
 
 SAMPS =	my.dtd my-show.act my-joke.xml my-joke2.xml my-joke3.xml \
 	tricky.dtd tricky.act tricky.xml \
-	test.html
+	test.html xhtml1-transitional.dtd
 
 SRC =	$(SAMPS)
 ALL =	$(SAMPS)
@@ -115,9 +115,6 @@
 
 # Complex example: application to print XHTML <a href=...> values.
 
-xhtml1-transitional.dtd:
-	wget 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'
-
 xhtml1-transitional.l xhtml1-transitional.h: xhtml1-transitional.dtd
 	$(FLEXML_PROG) -rhtml \
 		-p "-//IETF//DTD XHTML 1.0 Transitional//EN" \
@@ -126,6 +123,9 @@
 
 xhtml1-transitional.c:	xhtml1-transitional.l
 	$(FLEX) -B -s -v -Ca -oxhtml1-transitional.c xhtml1-transitional.l
+
+# turn off the -O2 when building this -- it takes too long to run
+xhtml1-transitional.o: CFLAGS = -g
 
 xhtml1-transitional.o:	xhtml1-transitional.c xhtml1-transitional.h
 
@@ -138,7 +138,7 @@
 	if ./xhtml-href <test.html   ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
 	if ./xhtml-href < FleXML.xml ; then echo "TEST PASSED"; else echo "TEST FAILED"; fi
 
-clean::; $(RM) xhtml1-*.dtd xhtml1-*.[lhco] xhtml-href.[co] xhtml-href
+clean::; $(RM) xhtml1-*.[lhco] xhtml-href.[co] xhtml-href
 
 # END.
